library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity PD_LED is
    Port ( CLK : in std_logic;
	 		  RST : in std_logic;

			  USB_DAT : in std_logic_vector( 7 downto 0 );
	 		  USB_RE  : in std_logic;

			  DISP_WR_N : out std_logic;
			  DISP_ADR  : out std_logic_vector( 2 downto 0 );
			  DISP_DAT  : out std_logic_vector( 7 downto 0 ) );
end PD_LED;

architecture RTL of PD_LED is

signal STATE : std_logic_vector( 3 downto 0 ); 

constant S0 : std_logic_vector := "0000";
constant S1 : std_logic_vector := "0001";
constant S2 : std_logic_vector := "0010";
constant S3 : std_logic_vector := "0011";
constant S4 : std_logic_vector := "0100";
constant S5 : std_logic_vector := "0101";
constant S6 : std_logic_vector := "0110";
constant S7 : std_logic_vector := "0111";
constant S8 : std_logic_vector := "1000";
constant S9 : std_logic_vector := "1001";
constant S10: std_logic_vector := "1010";
constant S11: std_logic_vector := "1011";
constant S12: std_logic_vector := "1100";
constant S13: std_logic_vector := "1101";
constant S14: std_logic_vector := "1110";
constant S15: std_logic_vector := "1111";

constant AST: std_logic_vector := "00101010";

begin

process( CLK, RST ) begin
	if ( RST ='1') then
		DISP_DAT   <= "00000000";
		DISP_ADR   <= "000";
		DISP_WR_N  <= '1';
		STATE      <= S0;
	elsif( CLK'event and CLK='1') then
		case STATE is
			when S0 =>
				if( USB_RE='1' and USB_DAT=AST ) then
					DISP_DAT <= "00XXXX11";
					DISP_ADR <= "0XX";
					DISP_WR_N <= '1';
					STATE <= S1;
				else 
					STATE <= S0;
				end if;
			when S1 =>
				DISP_WR_N <= '0';
				STATE <= S2;
			when S2 =>
				DISP_WR_N <= '1';
				STATE <= S3;
			-- 1
			when S3 =>
				if( USB_RE='1') then
					DISP_DAT  <= USB_DAT;
					DISP_ADR  <= "111";
					DISP_WR_N <= '1';
					STATE <= S4;
				else 
					STATE <= S3;
				end if;
			when S4 =>
				DISP_WR_N <= '0';
				STATE <= S5;
			when S5 =>
				DISP_WR_N <= '1';
				STATE <= S6;
			-- 2
			when S6 =>
				if( USB_RE='1') then
					DISP_DAT  <= USB_DAT;
					DISP_ADR  <= "110";
					DISP_WR_N <= '1';
					STATE <= S7;
				else 
					STATE <= S6;
				end if;
			when S7 =>
				DISP_WR_N <= '0';
				STATE <= S8;
			when S8 =>
				DISP_WR_N <= '1';
				STATE <= S9;
			-- 3
			when S9 =>
				if( USB_RE='1') then
					DISP_DAT  <= USB_DAT;
					DISP_ADR  <= "101";
					DISP_WR_N <= '1';
					STATE <= S10;
				else 
					STATE <= S9;
				end if;
			when S10 =>
				DISP_WR_N <= '0';
				STATE <= S11;
			when S11 =>
				DISP_WR_N <= '1';
				STATE <= S12;			
			-- 4
			when S12 =>
				if( USB_RE='1') then
					DISP_DAT  <= USB_DAT;
					DISP_ADR  <= "100";
					DISP_WR_N <= '1';
					STATE <= S13;
				else 
					STATE <= S12;
				end if;
			when S13 =>
				DISP_WR_N <= '0';
				STATE <= S14;
			when S14 =>
				DISP_WR_N <= '1';
				STATE <= S15;																																														
			when others => STATE <= S0;
		end case;
	end if;
end process;

end RTL;
