
-- VHDL Test Bench Created from source file usb_arbiter.vhd -- 13:04:52 07/04/2002
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT usb_arbiter
	PORT(
		CLK : IN std_logic;
		RST : IN std_logic;
		RXF_N : IN std_logic;
		TXE_N : IN std_logic;
		TG_READY : IN std_logic;
		TG_DI : IN std_logic_vector(7 downto 0);
		TG_WR : IN std_logic;    
		USB_DATA : INOUT std_logic_vector(7 downto 0);      
		RD_N : OUT std_logic;
		WR : OUT std_logic;
		BUS_BUSY : OUT std_logic;
		TG_DO : OUT std_logic_vector(7 downto 0);
		TG_RD : OUT std_logic
		);
	END COMPONENT;

	constant PERIOD :      time := 54.253 ns;
	constant PERIOD_DATA : time := 200 ns;

	SIGNAL CLK :  std_logic := '0';
	SIGNAL RST :  std_logic;
	SIGNAL RXF_N :  std_logic := '1';
	SIGNAL TXE_N :  std_logic := '0';
	SIGNAL RD_N :  std_logic;
	SIGNAL WR :  std_logic;
	SIGNAL BUS_BUSY :  std_logic;
	SIGNAL TG_READY :  std_logic := '1';
	SIGNAL USB_DATA :  std_logic_vector(7 downto 0) := "10101010";
	SIGNAL TG_DO :  std_logic_vector(7 downto 0);
	SIGNAL TG_DI :  std_logic_vector(7 downto 0):= "00000000";
	SIGNAL TG_RD :  std_logic;
	SIGNAL TG_WR :  std_logic := '0';

BEGIN

	uut: usb_arbiter PORT MAP(
		CLK => CLK,
		RST => RST,
		RXF_N => RXF_N,
		TXE_N => TXE_N,
		RD_N => RD_N,
		WR => WR,
		BUS_BUSY => BUS_BUSY,
		TG_READY => TG_READY,
		USB_DATA => USB_DATA,
		TG_DO => TG_DO,
		TG_DI => TG_DI,
		TG_RD => TG_RD,
		TG_WR => TG_WR
	);

-- RXF
process begin
RXF_N <= '1';
wait for PERIOD * 30;
RXF_N <= '0';
wait for PERIOD * 80;
RXF_N <= '1';
wait for PERIOD * 50;
RXF_N <= '0';
wait for PERIOD * 30;
RXF_N <= '1';
wait for PERIOD * 70;
end process;

-- TG_WR
process begin
	wait for PERIOD * 30;
	TG_WR <= not TG_WR;
	wait for PERIOD;
	TG_WR <= not TG_WR;
end process;

-- TG_READY
process begin
	wait for PERIOD*300;
	TG_READY <= not TG_READY;
	wait for PERIOD*50;
	TG_READY <= not TG_READY;
end process;

-- CLOCK
process begin
	wait for PERIOD/2;
	CLK <= not CLK;
end process;

-- RESET
process begin
	RST <= '1';
	wait for PERIOD;
	RST <= '0';
	wait ;
end process;

END;
